<?php

  class pz_xml
  {

    var $host;
    var $base;
    var $user;
    var $password;

    var $EXTENTION_OK;

    var $data_handlers;
    var $last_data_handler;

    function pz_xml($host, $base, $user, $password)
    { $this->host = $host.($host && substr($host, -1) != "/" ? "/" : "");
      $this->base = $base.($base && substr($base, -1) != "/" ? "/" : "");
      $this->user = $user;
      $this->password = $password;
      $this->data_handlers = array();
      $this->last_data_handler = 0;
      $this->EXTENTION_OK = true;
    }

    function connect($host, $base, $user, $password)
    { if($host.$base && is_dir($host.$base) && is_writable($host.$base)) return true;
      return null;
    }

    function select_db($base)
    { $this->base = $base.($base && substr($base, -1) != "/" ? "/" : "");
      return $this->connect($this->host, $this->base, $this->user, $this->password);
    }

    function create_data($data_path)
    { if(@mkdir($this->host.$this->base.$data_path))
      { if($dh = $this->open_data($data_path, false))
        { $this->close_data($dh);
          return true;
        }
      }
      return null;
    }

    function get_data($data_path, $data_id)
    { $dh = ++$this->last_data_handler;
      $this->data_handlers[$dh] = new pz_xml_data_handler($this->host, $this->base, $data_path);
      if($this->data_handlers[$dh]->open_data(false))
      { $res = $this->data_handlers[$dh]->get_data($data_id);
        $this->close_data($dh);
        return $res;
      }
      return null;
    }

    function open_data($data_path, $FETCH = true)
    { $dh = ++$this->last_data_handler;
      $this->data_handlers[$dh] = new pz_xml_data_handler($this->host, $this->base, $data_path);
      if($this->data_handlers[$dh]->open_data($FETCH))
      { return $dh;
      }
      $this->close_data($dh);
      return null;
    }

    function fetch_data($dh)
    { if(isset($this->data_handlers[$dh]))
      { return $this->data_handlers[$dh]->fetch_assoc();
      }
      return false;
    }

    function add_data($data_path, $data)
    { $dh = ++$this->last_data_handler;
      $this->data_handlers[$dh] = new pz_xml_data_handler($this->host, $this->base, $data_path);
      if($this->data_handlers[$dh]->open_data(false))
      { $res = $this->data_handlers[$dh]->add_data($data);
        $this->close_data($dh);
        return $res;
      }
      return null;
    }

    function last_index($dh)
    { if(isset($this->data_handlers[$dh]))
      { return $this->data_handlers[$dh]->last_index;
      }
      return null;
    }

    function set_data($data_path, $data_id, $data)
    { $dh = ++$this->last_data_handler;
      $this->data_handlers[$dh] = new pz_xml_data_handler($this->host, $this->base, $data_path);
      if($this->data_handlers[$dh]->open_data(false))
      { $res = $this->data_handlers[$dh]->set_data($data_id.".xml", $data);
        $this->close_data($dh);
        return $res;
      }
      return null;
    }

    function del_data($data_path, $data_id)
    { $dh = ++$this->last_data_handler;
      $this->data_handlers[$dh] = new pz_xml_data_handler($this->host, $this->base, $data_path);
      if($this->data_handlers[$dh]->open_data(false))
      { $res = $this->data_handlers[$dh]->del_data($data_id.".xml");
        $this->close_data($dh);
        return $res;
      }
      return null;
    }

    function close_data($dh)
    { if(isset($this->data_handlers[$dh]))
      { $this->data_handlers[$dh]->close_data();
        unset($this->data_handlers[$dh]);
      }
    }

  }

  class pz_xml_data_handler
  {
    var $sxml;
    var $host;
    var $base;
    var $data_path;
    var $data_path_handler;
    var $last_index;
    var $buffer;

    function pz_xml_data_handler($host, $base, $data_path)
    { $this->host = $host.(substr($host, -1) != "/" ? "/" : "");
      $this->base = $base.(substr($base, -1) != "/" ? "/" : "");
      $this->data_path = $data_path.(substr($data_path, -1) != "/" ? "/" : "");
    }

    function get_data($data_id)
    { if(file_exists($this->host.$this->base.$this->data_path.$data_id.".xml"))
      { if($this->buffer = @file_get_contents($this->host.$this->base.$this->data_path.$data_id.".xml"))
        { if(!isset($this->sxml)) $this->sxml = new sxml();
          $this->sxml->parse($this->buffer);
          $this->buffer = $this->sxml->data["tuple"][0];
          $v_rst = array();
          foreach($this->buffer["subs"] as $key => $value)
          { $v_rst[$key] = $value[0]["data"];
          }
          $v_rst["id"] = $data_id;
          return $v_rst;
        }
      }
      return false;
    }

    function open_data($FETCH = true)
    { clearstatcache();
      $INDEX_OK = false;
      if($this->host && $this->base && $this->data_path)
      { if(is_dir($this->host.$this->base.$this->data_path) && is_writable($this->host.$this->base.$this->data_path))
        { if(!file_exists($this->host.$this->base.$this->data_path.".index"))
          { if($fh = @fopen($this->host.$this->base.$this->data_path.".index", "w+"))
            { if(@fwrite($fh, "0"))
              { $this->last_index = 0;
                @fclose($fh);
                $INDEX_OK = true;
              }
              else @fclose($fh);
            }
          }
          else
          { if(($this->buffer = @file_get_contents($this->host.$this->base.$this->data_path.".index")) !== false)
            { if(preg_match("/^[0-9]+$/", $this->buffer))
              { $this->last_index = (int)$this->buffer;
                @fclose($fh);
                $INDEX_OK = true;
              }
              else @fclose($fh);
            }
            else @fclose($fh);
          }
        }
      }
      if($INDEX_OK)
      { if($FETCH)
        { if($this->data_path_handler = @opendir($this->host.$this->base.$this->data_path))
          { return true;
          }
          else
          { $this->close_data();
            return null;
          }
        }
        else return true;
      }
      else
      { $this->close_data();
        return null;
      }
    }

    function fetch_assoc()
    { if($this->data_path_handler)
      { $FORMAT_OK = false;
        while(!$FORMAT_OK && ($data_file = @readdir($this->data_path_handler)) !== false)
        { if(substr($data_file, 0, 1) != "." && substr($data_file, -4) == ".xml") $FORMAT_OK = true;
        }
        if($FORMAT_OK)
        { if($this->buffer = @file_get_contents($this->host.$this->base.$this->data_path.$data_file))
          { if(!isset($this->sxml)) $this->sxml = new sxml();
            $this->sxml->parse($this->buffer);
            $this->buffer = $this->sxml->data["tuple"][0];
            $v_rst = array();
            foreach($this->buffer["subs"] as $key => $value)
            { $v_rst[$key] = $value[0]["data"];
            }
            $v_rst["id"] = substr($data_file, 0, -4);
            return $v_rst;
          }
        }
      }
      return false;
    }

    function add_data($data)
    { $index = $this->inc_index();
      if(isset($index))
      { if(is_array($data))
        { if($fh = @fopen($this->host.$this->base.$this->data_path.$index.".xml", "w"))
          { $this->buffer = "<tuple>\n";
            foreach($data as $key => $value)
            { $this->buffer .= "  <".$key."><![CDATA[".$value."]]></".$key.">\n";
            }
            $this->buffer .= "</tuple>\n";
            if(@fwrite($fh, $this->buffer) !== false)
            { @fclose($fh);
              $this->buffer = null;
              return true;
            }
            else
            { @fclose($fh);
              $this->buffer = null;
            }
          }
        }
      }
      return null;
    }

    function inc_index()
    { clearstatcache();
      if(isset($this->last_index))
      { $index = $this->last_index + 1;
        if($fh = @fopen($this->host.$this->base.$this->data_path.".index", "w+"))
        { if(@fwrite($fh, (string)$index))
          { $this->last_index = $index;
            @fclose($fh);
            return $index;
          }
          else @fclose($fh);
        }
      }
      return null;
    }

    function set_data($data_file, $data)
    { if(preg_match("/^[0-9]+\.xml$/", $data_file))
      { if(is_writable($this->host.$this->base.$this->data_path.$data_file))
        { if(is_array($data))
          { if($fh = @fopen($this->host.$this->base.$this->data_path.$data_file, "w+"))
            { $this->buffer = "<tuple>\n";
              foreach($data as $key => $value)
              { $this->buffer .= "  <".$key."><![CDATA[".$value."]]></".$key.">\n";
              }
              $this->buffer .= "</tuple>\n";
              if(@fwrite($fh, $this->buffer) !== false)
              { @fclose($fh);
                $this->buffer = null;
                return true;
              }
              else
              { @fclose($fh);
                $this->buffer = null;
              }
            }
          }
        }
      }
      return null;
    }

    function del_data($data_file)
    { if(preg_match("/^[0-9]+\.xml$/", $data_file))
      { if(is_file($this->host.$this->base.$this->data_path.$data_file))
        { return @unlink($this->host.$this->base.$this->data_path.$data_file);
        }
      }
      return null;
    }

    function close_data()
    { $this->sxml = null;
      $this->data_path= null;
      if($this->data_path_handler) @closedir($this->data_path_handler);
      $this->last_index = null;
      $this->buffer = null;
    }

  }

?>